searchNodes=[{"ref":"Horde.Cluster.html","title":"Horde.Cluster","type":"module","doc":"Public functions to join and leave hordes. Calling Horde.Cluster.set_members/2 will join the given members in a cluster. Cluster membership is propagated via a CRDT, so setting it once on a single node is sufficient. {:ok, sup1} = Horde.DynamicSupervisor.start_link([], name: :supervisor_1, strategy: :one_for_one) {:ok, sup2} = Horde.DynamicSupervisor.start_link([], name: :supervisor_2, strategy: :one_for_one) {:ok, sup3} = Horde.DynamicSupervisor.start_link([], name: :supervisor_3, strategy: :one_for_one) :ok = Horde.Cluster.set_members(:supervisor_1, [:supervisor_1, :supervisor_2, :supervisor_3])"},{"ref":"Horde.Cluster.html#members/1","title":"Horde.Cluster.members/1","type":"function","doc":"Get the members (nodes) of the horde"},{"ref":"Horde.Cluster.html#set_members/3","title":"Horde.Cluster.set_members/3","type":"function","doc":""},{"ref":"Horde.Cluster.html#t:member/0","title":"Horde.Cluster.member/0","type":"type","doc":""},{"ref":"Horde.Cluster.html#t:name/0","title":"Horde.Cluster.name/0","type":"type","doc":""},{"ref":"Horde.DistributionStrategy.html","title":"Horde.DistributionStrategy","type":"behaviour","doc":"Define your own distribution strategy by implementing this behaviour and configuring Horde to use it. See Horde.UniformQuorumDistribution and Horde.UniformDistribution for examples."},{"ref":"Horde.DistributionStrategy.html#c:choose_node/2","title":"Horde.DistributionStrategy.choose_node/2","type":"callback","doc":""},{"ref":"Horde.DistributionStrategy.html#c:has_quorum?/1","title":"Horde.DistributionStrategy.has_quorum?/1","type":"callback","doc":""},{"ref":"Horde.DistributionStrategy.html#t:t/0","title":"Horde.DistributionStrategy.t/0","type":"type","doc":""},{"ref":"Horde.DynamicSupervisor.html","title":"Horde.DynamicSupervisor","type":"behaviour","doc":"A distributed supervisor. Horde.DynamicSupervisor implements a distributed DynamicSupervisor backed by a add-wins last-write-wins δ-CRDT (provided by DeltaCrdt.AWLWWMap). This CRDT is used for both tracking membership of the cluster and tracking supervised processes. Using CRDTs guarantees that the distributed, shared state will eventually converge. It also means that Horde.DynamicSupervisor is eventually-consistent, and is optimized for availability and partition tolerance. This can result in temporary inconsistencies under certain conditions (when cluster membership is changing, for example). Cluster membership is managed with Horde.Cluster. Joining a cluster can be done with Horde.Cluster.set_members/2. To take a node out of the cluster, call Horde.Cluster.set_members/2 without that node in the list. Each Horde.DynamicSupervisor node wraps its own local instance of DynamicSupervisor. Horde.Supervisor.start_child/2 (for example) delegates to the local instance of DynamicSupervisor to actually start and monitor the child. The child spec is also written into the processes CRDT, along with a reference to the node on which it is running. When there is an update to the processes CRDT, Horde makes a comparison and corrects any inconsistencies (for example, if a conflict has been resolved and there is a process that no longer should be running on its node, it will kill that process and remove it from the local supervisor). So while most functions map 1:1 to the equivalent DynamicSupervisor functions, the eventually consistent nature of Horde requires extra behaviour not present in DynamicSupervisor. Divergence from standard DynamicSupervisor behaviour While Horde wraps DynamicSupervisor, it does keep track of processes by the id in the child specification. This is a divergence from the behaviour of DynamicSupervisor, which ignores ids altogether. Using DynamicSupervisor is useful for its shutdown behaviour (it shuts down all child processes simultaneously, unlike Supervisor). Graceful shutdown When a node is stopped (either manually or by calling :init.stop), Horde restarts the child processes of the stopped node on another node. The state of child processes is not preserved, they are simply restarted. To implement graceful shutdown of worker processes, a few extra steps are necessary. Trap exits. Running Process.flag(:trap_exit) in the init/1 callback of any worker processes will convert exit signals to messages and allow running terminate/2 callbacks. It is also important to include the shutdown option in your child spec (the default is 5000ms). Use :init.stop() to shut down your node. How you accomplish this is up to you, but by simply calling :init.stop() somewhere, graceful shutdown will be triggered. Module-based Supervisor Horde supports module-based supervisors to enable dynamic runtime configuration. defmodule MySupervisor do use Horde.DynamicSupervisor def start_link(init_arg, options \\ []) do Horde.DynamicSupervisor.start_link(__MODULE__, init_arg, options) end def init(init_arg) do [strategy: :one_for_one, members: members()] |&gt; Keyword.merge(init_arg) |&gt; Horde.DynamicSupervisor.init() end defp members() do [] end end Then you can use MySupervisor.child_spec/1 and MySupervisor.start_link/1 in the same way as you&#39;d use Horde.DynamicSupervisor.child_spec/1 and Horde.Supervisor.start_link/1."},{"ref":"Horde.DynamicSupervisor.html#child_spec/1","title":"Horde.DynamicSupervisor.child_spec/1","type":"function","doc":"See start_link/2 for options."},{"ref":"Horde.DynamicSupervisor.html#c:child_spec/1","title":"Horde.DynamicSupervisor.child_spec/1","type":"callback","doc":""},{"ref":"Horde.DynamicSupervisor.html#count_children/1","title":"Horde.DynamicSupervisor.count_children/1","type":"function","doc":"Works like DynamicSupervisor.count_children/1. This function delegates to all supervisors in the cluster and returns the aggregated output."},{"ref":"Horde.DynamicSupervisor.html#init/1","title":"Horde.DynamicSupervisor.init/1","type":"function","doc":"Works like DynamicSupervisor.init/1."},{"ref":"Horde.DynamicSupervisor.html#c:init/1","title":"Horde.DynamicSupervisor.init/1","type":"callback","doc":""},{"ref":"Horde.DynamicSupervisor.html#members/2","title":"Horde.DynamicSupervisor.members/2","type":"function","doc":""},{"ref":"Horde.DynamicSupervisor.html#start_child/2","title":"Horde.DynamicSupervisor.start_child/2","type":"function","doc":"Works like DynamicSupervisor.start_child/2."},{"ref":"Horde.DynamicSupervisor.html#start_link/1","title":"Horde.DynamicSupervisor.start_link/1","type":"function","doc":"Works like DynamicSupervisor.start_link/1. Extra options are documented here: :distribution_strategy, defaults to Horde.UniformDistribution but can also be set to Horde.UniformQuorumDistribution. Horde.UniformQuorumDistribution enforces a quorum and will shut down all processes on a node if it is split from the rest of the cluster."},{"ref":"Horde.DynamicSupervisor.html#start_link/3","title":"Horde.DynamicSupervisor.start_link/3","type":"function","doc":""},{"ref":"Horde.DynamicSupervisor.html#stop/3","title":"Horde.DynamicSupervisor.stop/3","type":"function","doc":"Works like DynamicSupervisor.stop/3."},{"ref":"Horde.DynamicSupervisor.html#terminate_child/2","title":"Horde.DynamicSupervisor.terminate_child/2","type":"function","doc":"Terminate a child process. Works like DynamicSupervisor.terminate_child/2."},{"ref":"Horde.DynamicSupervisor.html#wait_for_quorum/2","title":"Horde.DynamicSupervisor.wait_for_quorum/2","type":"function","doc":"Waits for Horde.DynamicSupervisor to have quorum."},{"ref":"Horde.DynamicSupervisor.html#which_children/1","title":"Horde.DynamicSupervisor.which_children/1","type":"function","doc":"Works like DynamicSupervisor.which_children/1. This function delegates to all supervisors in the cluster and returns the aggregated output. Where memory warnings apply to DynamicSupervisor.which_children, these count double for Horde.DynamicSupervisor.which_children."},{"ref":"Horde.DynamicSupervisor.html#t:option/0","title":"Horde.DynamicSupervisor.option/0","type":"type","doc":""},{"ref":"Horde.DynamicSupervisor.html#t:options/0","title":"Horde.DynamicSupervisor.options/0","type":"type","doc":""},{"ref":"Horde.Registry.html","title":"Horde.Registry","type":"behaviour","doc":"A distributed process registry. Horde.Registry implements a distributed Registry backed by a δ-CRDT (provided by DeltaCrdt). This CRDT is used for both tracking membership of the cluster and implementing the registry functionality itself. Local changes to the registry will automatically be synced to other nodes in the cluster. Cluster membership is managed with Horde.Cluster. Joining a cluster can be done with Horde.Cluster.set_members/2. To take a node out of the cluster, call Horde.Cluster.set_members/2 without that node in the list. Horde.Registry supports the common &quot;via tuple&quot;, described in the documentation for GenServer. Horde.Registry is API-compatible with Registry, with the following exceptions: Horde.Registry does not support keys: :duplicate. Horde.Registry does not support partitions. Horde.Registry sends an exit signal to a process when it has lost a naming conflict. See Horde.Registry.register/3 for details. Module-based Registry Horde supports module-based registries to enable dynamic runtime configuration. defmodule MyRegistry do use Horde.Registry def start_link(init_arg, options \\ []) Horde.Registry.start_link(__MODULE__, init_arg, options) end def init(init_arg) do [members: members()] |&gt; Keyword.merge(init_arg) |&gt; Horde.Registry.init() end defp members() do # ... end end Then you can use MyRegistry.child_spec/1 and MyRegistry.start_link/1 in the same way as you&#39;d use Horde.Registry.child_spec/1 and Horde.Registry.start_link/1."},{"ref":"Horde.Registry.html#child_spec/1","title":"Horde.Registry.child_spec/1","type":"function","doc":"See start_link/2 for options."},{"ref":"Horde.Registry.html#c:child_spec/1","title":"Horde.Registry.child_spec/1","type":"callback","doc":""},{"ref":"Horde.Registry.html#count/1","title":"Horde.Registry.count/1","type":"function","doc":"See Registry.count/1."},{"ref":"Horde.Registry.html#count_match/4","title":"Horde.Registry.count_match/4","type":"function","doc":"See Registry.count_match/4."},{"ref":"Horde.Registry.html#dispatch/4","title":"Horde.Registry.dispatch/4","type":"function","doc":"See Registry.dispatch/4."},{"ref":"Horde.Registry.html#init/1","title":"Horde.Registry.init/1","type":"function","doc":"Works like Registry.init/1."},{"ref":"Horde.Registry.html#c:init/1","title":"Horde.Registry.init/1","type":"callback","doc":""},{"ref":"Horde.Registry.html#keys/2","title":"Horde.Registry.keys/2","type":"function","doc":"See Registry.keys/2."},{"ref":"Horde.Registry.html#lookup/1","title":"Horde.Registry.lookup/1","type":"function","doc":"See Registry.lookup/2."},{"ref":"Horde.Registry.html#lookup/2","title":"Horde.Registry.lookup/2","type":"function","doc":""},{"ref":"Horde.Registry.html#match/4","title":"Horde.Registry.match/4","type":"function","doc":"See Registry.match/4."},{"ref":"Horde.Registry.html#members/2","title":"Horde.Registry.members/2","type":"function","doc":""},{"ref":"Horde.Registry.html#meta/2","title":"Horde.Registry.meta/2","type":"function","doc":"See Registry.meta/2."},{"ref":"Horde.Registry.html#put_meta/3","title":"Horde.Registry.put_meta/3","type":"function","doc":"See Registry.put_meta/3."},{"ref":"Horde.Registry.html#register/3","title":"Horde.Registry.register/3","type":"function","doc":"Register a process under the given name. See Registry.register/3. When 2 clustered registries register the same name at exactly the same time, it will seem like name registration succeeds for both registries. The function returns {:ok, pid} for both of these calls. However, due to the eventually consistent nature of the CRDT, conflict resolution will take place, and the CRDT will pick one of the two processes as the &quot;winner&quot; of the name. The losing process will be sent an exit signal (using Process.exit/2) with the following reason: {:name_conflict, {name, value}, registry_name, winning_pid} When two registries are joined using Horde.Cluster.set_members/2, this name conflict message can also occur. When a cluster is recovering from a netsplit, this name conflict message can also occur."},{"ref":"Horde.Registry.html#select/2","title":"Horde.Registry.select/2","type":"function","doc":"See Registry.select/2."},{"ref":"Horde.Registry.html#start_link/1","title":"Horde.Registry.start_link/1","type":"function","doc":"See Registry.start_link/1. Does not accept [partitions: x], nor [keys: :duplicate] as options."},{"ref":"Horde.Registry.html#start_link/3","title":"Horde.Registry.start_link/3","type":"function","doc":""},{"ref":"Horde.Registry.html#stop/3","title":"Horde.Registry.stop/3","type":"function","doc":""},{"ref":"Horde.Registry.html#unregister/2","title":"Horde.Registry.unregister/2","type":"function","doc":"See Registry.unregister/2."},{"ref":"Horde.Registry.html#unregister_match/4","title":"Horde.Registry.unregister_match/4","type":"function","doc":"See Registry.unregister_match/4."},{"ref":"Horde.Registry.html#update_value/3","title":"Horde.Registry.update_value/3","type":"function","doc":"See Registry.update_value/3."},{"ref":"Horde.Registry.html#t:option/0","title":"Horde.Registry.option/0","type":"type","doc":""},{"ref":"Horde.UniformDistribution.html","title":"Horde.UniformDistribution","type":"module","doc":"Distributes processes to nodes uniformly using a hash ring"},{"ref":"Horde.UniformDistribution.html#choose_node/2","title":"Horde.UniformDistribution.choose_node/2","type":"function","doc":"Callback implementation for Horde.DistributionStrategy.choose_node/2."},{"ref":"Horde.UniformDistribution.html#has_quorum?/1","title":"Horde.UniformDistribution.has_quorum?/1","type":"function","doc":"Callback implementation for Horde.DistributionStrategy.has_quorum?/1."},{"ref":"Horde.UniformQuorumDistribution.html","title":"Horde.UniformQuorumDistribution","type":"module","doc":"Distributes processes to nodes uniformly using a hash ring. Contains a quorum mechanism to handle netsplits."},{"ref":"Horde.UniformQuorumDistribution.html#choose_node/2","title":"Horde.UniformQuorumDistribution.choose_node/2","type":"function","doc":"Callback implementation for Horde.DistributionStrategy.choose_node/2."},{"ref":"Horde.UniformQuorumDistribution.html#has_quorum?/1","title":"Horde.UniformQuorumDistribution.has_quorum?/1","type":"function","doc":"Callback implementation for Horde.DistributionStrategy.has_quorum?/1."},{"ref":"readme.html","title":"Horde","type":"extras","doc":"Horde Distribute your application over multiple servers with Horde. Horde is comprised of Horde.DynamicSupervisor, a distributed supervisor, and Horde.Registry, a distributed registry. Horde is built on top of DeltaCrdt. Read the full documentation on hexdocs.pm. There is an introductory blog post and a getting started guide. You can also find me in the Elixir slack channel #horde. Daniel Azuma gave a great talk at ElixirConf US 2018 where he demonstrated Horde&#39;s Supervisor and Registry. Since Horde is built on CRDTs, it is eventually (as opposed to immediately) consistent, although it does sync its state with its neighbours rather aggressively. Cluster membership in Horde is fully dynamic; nodes can be added and removed at any time and Horde will continue to operate as expected. Horde.DynamicSupervisor also uses a hash ring to limit any possible race conditions to times when cluster membership is changing. Horde.Registry is API-compatible with Elixir&#39;s own Registry, although it does not yet support the keys: :duplicate option. For many use cases, it will be a drop-in replacement. Horde.DynamicSupervisor follows the API and behaviour of DynamicSupervisor as closely as possible. There will always be some difference between Horde and its standard library equivalents, if not in their APIs, then in their functionality. This is a necessary consequence of Horde&#39;s distributed nature."},{"ref":"readme.html#1-0-release","title":"Horde - 1.0 release","type":"extras","doc":"Help us get to 1.0, please fill out our very short survey and report any issues you encounter when using Horde."},{"ref":"readme.html#fault-tolerance","title":"Horde - Fault tolerance","type":"extras","doc":"If a node fails (or otherwise becomes unreachable) then Horde.DynamicSupervisor will redistribute processes among the remaining nodes. You can choose what to do in the event of a network partition by specifying :distribution_strategy in the options for Horde.DynamicSupervisor.start_link/2. Setting this option to Horde.UniformDistribution (which is the default) distributes processes using a hash mechanism among all reachable nodes. In the event of a network partition, both sides of the partition will continue to operate. Setting it to Horde.UniformQuorumDistribution will operate in the same way, but will shut down if less than half of the cluster is reachable."},{"ref":"readme.html#cap-theorem","title":"Horde - CAP Theorem","type":"extras","doc":"Horde is eventually consistent, which means that Horde can guarantee availability and partition tolerancy. Horde cannot guarantee consistency. This means you may end up with duplicate processes in your cluster. Horde does aggressively synchronize between nodes (this is also tunable), but ultimately, depending on the tuning parameters you choose and the quality of the network, there are conditions under which it is possible to have duplicate processes in your cluster. Horde.Registry terminates duplicate processes as soon as they are discovered with a special exit code, so you&#39;ll always know when this is happening. See this page in the docs for more details. NOTE: Since Horde 0.6.0, Horde.DynamicSupervisor ignores the id of a child spec (as Elixir.DynamicSupervisor does), and therefore does not guarantee that each id will be unique in the cluster (as it did pre-0.6.0). If you want to uniquely name your processes in a cluster, use Horde.Registry for this purpose. Having both Horde.DynamicSupervisor and Horde.Registry checking for uniqueness was subject to a race condition where Horde.DynamicSupervisor would choose process A to survive and Horde.Registry would choose process B to survive, resulting in both processes being killed."},{"ref":"readme.html#graceful-shutdown","title":"Horde - Graceful shutdown","type":"extras","doc":"Using Horde.DynamicSupervisor.stop/3 will cause the local supervisor to stop and any processes it was running will be shut down and redistributed to remaining supervisers in the horde. (This should happen automatically if :init.stop() is called)."},{"ref":"readme.html#installation","title":"Horde - Installation","type":"extras","doc":"Horde is available in Hex. The package can be installed by adding horde to your list of dependencies in mix.exs: def deps do [ {:horde, &quot;~&gt; 0.7.0&quot;} ] end"},{"ref":"readme.html#usage","title":"Horde - Usage","type":"extras","doc":"Here is a small taste of Horde&#39;s usage. See the full docs at https://hexdocs.pm/horde for more information and examples. There is also an example application at examples/hello_world that you can refer to if you get stuck. Starting Horde.DynamicSupervisor: defmodule MyApp.Application do use Application def start(_type, _args) do children = [ {Horde.DynamicSupervisor, [name: MyApp.DistributedSupervisor, strategy: :one_for_one]} ] Supervisor.start_link(children, strategy: :one_for_one) end end Adding a child to the supervisor: # Add a Task Horde.DynamicSupervisor.start_child(MyApp.DistributedSupervisor, %{id: :task, start: {Task, :start_link, [:infinity]}}) # Add an Agent Horde.DynamicSupervisor.start_child(MyApp.DistributedSupervisor, %{id: :agent, start: {Agent, :start_link, [fn -&gt; %{} end]}}) # Add a GenServer: You need a previously defined GenServer to call the one # liner below. We have a test (&quot;graceful shutdown&quot;) in # `test/supervisor_test.exs` that exercises and displays that behavior. After # defined, it would be very similar to this: Horde.DynamicSupervisor.start_child(MyApp.DistributedSupervisor, %{id: :gen_server, start: {GenServer, :start_link, [DefinedGenServer, {500, pid}]}}) And so on. The public API should be the same as Elixir.DynamicSupervisor (and please open an issue if you find a difference). Joining supervisors into a single distributed supervisor can be done using Horde.Cluster: {:ok, supervisor_1} = Horde.DynamicSupervisor.start_link(name: :distributed_supervisor_1, strategy: :one_for_one) {:ok, supervisor_2} = Horde.DynamicSupervisor.start_link(name: :distributed_supervisor_2, strategy: :one_for_one) {:ok, supervisor_3} = Horde.DynamicSupervisor.start_link(name: :distributed_supervisor_3, strategy: :one_for_one) Horde.Cluster.set_members(:distributed_supervisor_1, [:distributed_supervisor_1, :distributed_supervisor_2, :distributed_supervisor_3]) # supervisor_1, supervisor_2 and supervisor_3 will be joined in a single cluster. Contributing Contributions are welcome! Feel free to open an issue if you&#39;d like to discuss a problem or a possible solution. Pull requests are much appreciated."},{"ref":"changelog.html","title":"CHANGELOG","type":"extras","doc":""},{"ref":"changelog.html#master","title":"CHANGELOG - master","type":"extras","doc":""},{"ref":"changelog.html#0-7-0","title":"CHANGELOG - 0.7.0","type":"extras","doc":"Horde.Supervisor has been renamed to Horde.DynamicSupervisor. Horde.Registry and Horde.Supervisor now follow the api of Elixir.DynamicSupervisor more closely (specifically init/1 callback and module-based Supervisor / Registry). #152. Horde.Registry.lookup/2 returns [] instead of :undefined when no match. #145 child_spec/1 can be overridden in Horde.Registry and Horde.Supervisor #135 #143 Implement :listeners option for Horde.Registry. #142 Fix via tuple usage with meta. #139"},{"ref":"changelog.html#0-6-1","title":"CHANGELOG - 0.6.1","type":"extras","doc":"Module-based Horde.Supervisor can override child_spec/1. #135 Added guides for handling clustering, process state handoff (during deploys), and special considerations for eventual consistency to the documentation. Horde.Supervisor now uses libring to distribute processes over nodes. #130 Horde.Supervisor publishes metrics with :telemetry ([:horde, :supervisor, :supervised_process_count]). #132 Horde.Supervisor and Horde.Registry now support option delta_crdt_options, which you can use to tune your cluster. Also updated to the most recent DeltaCRDT. #100"},{"ref":"changelog.html#0-6-0","title":"CHANGELOG - 0.6.0","type":"extras","doc":"Horde.Supervisor now behaves more like DynamicSupervisor. #122 Horde.Registry sends an exit signal to the process that &quot;loses&quot; when a conflict is resolved. #118 Horde.Registry.register/3 returns {:error, {:already_registered, pid}} when applicable. This improves compatability with Elixir.Registry. #115 Adds Horde.Registry.select/2, which works the same as Elixir.Registry.select/2, which will land in Elixir 1.9. #110 Fixes a bug causing Horde.Supervisor to crash if a child process was restarting when Horde.Supervisor.delete_child/2 was called. #114"},{"ref":"getting_started.html","title":"Getting Started","type":"extras","doc":"Getting Started This guide shows you how to get started with Horde. Code samples come from the example HelloWorld app in examples/hello_world."},{"ref":"getting_started.html#erlang-clustering","title":"Getting Started - Erlang clustering","type":"extras","doc":"Horde relies on Erlang&#39;s built in clustering. To make this work, each node in our cluster needs a unique name, and each node must be started using the same cookie. We can try this out locally like so: iex --name node1@127.0.0.1 --cookie asdf -S mix iex --name node2@127.0.0.1 --cookie asdf -S mix iex --name node3@127.0.0.1 --cookie asdf -S mix In this example each node has a unique name, and they all share the same cookie. Now we can connect these nodes by running the following code: Node.connect(:&quot;node2@127.0.0.1&quot;) Run Node.list() to confirm that the nodes are connected. Horde assumes that you will manage Erlang clustering yourself. There are libraries that will help you do this. Continue reading the getting started guide and when you are getting ready to deploy your application, read about how to set up a cluster."},{"ref":"getting_started.html#starting-horde-dynamicsupervisor","title":"Getting Started - Starting Horde.DynamicSupervisor","type":"extras","doc":"Horde.DynamicSupervisor is API-compatible with Elixir&#39;s DynamicSupervisor. There are extra arguments that you can provide, but the basic recipe stays the same: defmodule HelloWorld.Application do use Application def start(_type, _args) do children = [ {Horde.DynamicSupervisor, [name: HelloWorld.HelloSupervisor, strategy: :one_for_one]}, ] opts = [strategy: :one_for_one, name: HelloWorld.Supervisor] Supervisor.start_link(children, opts) end end This is also where you can set additional options for Horde.DynamicSupervisor: :members, a list of members (if your cluster will have static membership) :distribution_strategy, the distribution strategy (Horde.UniformDistribution is default) :delta_crdt_options, for tuning the delta CRDT that underpins Horde See the documentation for Horde.DynamicSupervisor for more information."},{"ref":"getting_started.html#starting-horde-registry","title":"Getting Started - Starting Horde.Registry","type":"extras","doc":"Horde.DynamicSupervisor is spreading your processes out over the cluster, but how do you know where all these processes are? Horde.Registry is the answer. We want Horde.Registry to be above Horde.Supervisor in the start-up order. This is what our example above looks like with Horde.Registry added in: defmodule HelloWorld.Application do use Application def start(_type, _args) do children = [ {Horde.Registry, [name: HelloWorld.HelloRegistry, keys: :unique]}, {Horde.DynamicSupervisor, [name: HelloWorld.HelloSupervisor, strategy: :one_for_one]}, ] opts = [strategy: :one_for_one, name: HelloWorld.Supervisor] Supervisor.start_link(children, opts) end end There are also some additional options for Horde.Registry: :members, a list of members (if your cluster will have static membership) :delta_crdt_options, for tuning the delta CRDT that underpins Horde See the documentation for Horde.Registry for more information."},{"ref":"getting_started.html#running-a-genserver","title":"Getting Started - Running a GenServer","type":"extras","doc":"Let&#39;s create a very simple GenServer that we will use to run in our example application to test things out a little. defmodule HelloWorld.SayHello do use GenServer require Logger def child_spec(opts) do name = Keyword.get(opts, :name, __MODULE__) %{ id: &quot;\#{__MODULE__}_\#{name}&quot;, start: {__MODULE__, :start_link, [name]}, shutdown: 10_000, restart: :transient } end def start_link(name) do case GenServer.start_link(__MODULE__, [], name: via_tuple(name)) do {:ok, pid} -&gt; {:ok, pid} {:error, {:already_started, pid}} -&gt; Logger.info(&quot;already started at \#{inspect(pid)}, returning :ignore&quot;) :ignore end end def init(_args) do {:ok, nil} end def via_tuple(name), do: {:via, Horde.Registry, {HelloWorld.HelloRegistry, name}} end This GenServer can be started by running the following line of code: Horde.DynamicSupervisor.start_child(HelloWorld.HelloSupervisor, HelloWorld.SayHello). Once running, you can address this GenServer with the following line of code: GenServer.call(via_tuple(HelloWorld.SayHello), msg)."},{"ref":"getting_started.html#next-steps","title":"Getting Started - Next Steps","type":"extras","doc":"Now you should have a working installation of Horde. There is more information available in the other guides, so don&#39;t forget to read those too. If you get stuck or have suggestions on how this guide could be improved, please open an issue on Github."},{"ref":"eventual_consistency.html","title":"Eventual Consistency","type":"extras","doc":"Eventual Consistency Horde uses a CRDT to sync data between nodes. This means that two nodes in your cluster can have a different view of the data, with differences being merged as the nodes sync with each other. We call this &quot;eventually consistent&quot;, and the result is that we have to deal with merge conflicts and race conditions. Horde&#39;s CRDT automatically resolves conflicts, but we still have to deal with the after-effects."},{"ref":"eventual_consistency.html#horde-dynamicsupervisor-merge-conflict","title":"Eventual Consistency - Horde.DynamicSupervisor merge conflict","type":"extras","doc":"It is unlikely, but possible, that Horde.DynamicSupervisor will start the same process on two separate nodes. This can happen: if using a custom distribution strategy, or when a node dies and not all nodes have the same view of the cluster, or if there is a network partition. Once a network partition has healed, Horde will automatically terminate any duplicate processes."},{"ref":"eventual_consistency.html#horde-registry-merge-conflict","title":"Eventual Consistency - Horde.Registry merge conflict","type":"extras","doc":"When processes on two different nodes have claimed the same name, this will generate a conflict in Horde.Registry. The CRDT resolves the conflict and Horde.Registry sends an exit signal to the process that lost the conflict. This can be a common occurrence. Unless this message is handled, it will cause the process to exit. Handling the exit message isn&#39;t strictly necessary, because we usually want the process to exit in this case. If for some reason you want to handle the message, simply trap exits in the init/1 callback and handle the message as follows: def init(arg) do Process.flag(:trap_exit, true) {:ok, state} end def handle_info({:EXIT, _from, {:name_conflict, {key, value}, registry, pid}}, state) do # handle the message, add some logging perhaps, and probably stop the GenServer. {:stop, state} end Note that, unless your process has restart: :transient in its child spec and you have handled the message to shut down the process cleanly, it will be restarted by its supervisor. Upon restart, it will try to register itself. This will of course fail. If using a via tuple, the following approach is necessary. def start_link(arg) do case GenServer.start_link(...) do {:ok, pid} -&gt; {:ok, pid} {:error, {:already_started, pid}} -&gt; :ignore end end If you are using Horde.Registry.register/3 in init/1, then you must handle {:error, {:already_started, pid}}. def init(arg) do case Horde.Registry.register(:my_registry, &quot;key&quot;, &quot;value&quot;) do {:ok, _pid} -&gt; {:ok, arg} {:error, {:already_started, _pid}} -&gt; :ignore end end"},{"ref":"state_handoff.html","title":"State Handoff","type":"extras","doc":"State Handoff During deployment, when a server is restarted, its processes are restarted on other nodes. It can be useful to hand off state from the process that is shutting down to the process that is starting up. Horde does not offer a specialized state handoff feature, instead we will be using OTP to accomplish state handoff."},{"ref":"state_handoff.html#trapping-exits","title":"State Handoff - Trapping exits","type":"extras","doc":"When Horde.DynamicSupervisor is shutting down, it will send an exit signal to its child processes. We need to trap this signal to ensure that our terminate/2 callback gets called. def init(arg) do Process.flag(:trap_exit, true) {:ok, arg} end"},{"ref":"state_handoff.html#saving-state","title":"State Handoff - Saving state","type":"extras","doc":"We can then save the state in the terminate function. def terminate(reason, state) do save_state(state) # save state to Redis, DeltaCRDT, Postgres, Mysql, etc. end"},{"ref":"state_handoff.html#shutdown-timeout","title":"State Handoff - Shutdown timeout","type":"extras","doc":"The default shutdown timeout is 0, which of course does not leave enough time to save our state. Increase the value of shutdown to make sure that your process has enough time to save its data. Be aware: shutdown must be set at all levels of your application to apply. A more restrictive shutdown timeout at a higher level in the supervision tree will override less restrictive values. children = [{Horde.DynamicSupervisor, [name: :my_supervisor, shutdown: 1000, strategy: :one_for_one]}]"},{"ref":"state_handoff.html#restoring-state","title":"State Handoff - Restoring state","type":"extras","doc":"Now we have to modify the init/1 callback to restore the state when the process is initializing. We put this in a handle_continue/2 callback to avoid making the supervisor wait unnecessarily for the state to load. def init(arg) do Process.flag(:trap_exit, true) {:ok, arg, {:continue, :load_state}} end def handle_continue(:load_state, arg) do {:noreply, load_state(arg)} end !!WARNING!! We must be careful not to accidentally load invalid state into our processes. For example, if the state of a process changes between deploys, then you might load invalid state and cause your process to crash. Here are some other things to look out for: loading stale data loading data fails, causing process to crash there is no data to load, causing process to crash Anytime we are loading state into our processes from an external source, we should be very careful. Erlang&#39;s &quot;let it crash&quot; philosophy is predicated on the idea that a process will be in a known good state after a restart, and if we subvert this by loading invalid state, it could have a negative impact on the stability of our system."},{"ref":"libcluster.html","title":"Setting up a Cluster","type":"extras","doc":"Setting up a Cluster Horde doesn&#39;t provide functionality to set up your cluster, we recommend you use libcluster for this purpose. There are two strategies you can use to integrate libcluster with Horde:"},{"ref":"libcluster.html#static-cluster-membership","title":"Setting up a Cluster - Static Cluster Membership","type":"extras","doc":"If you will not be adding or removing members from the cluster dynamically, then you can set up libcluster and tell Horde about the members of your cluster. For example, if you run your cluster on bare metal hardware and have a fixed number of servers. supervisor_members = [ {MyHordeSupervisor, :node1}, {MyHordeSupervisor, :node2}, {MyHordeSupervisor, :node3}, {MyHordeSupervisor, :node4} ] registry_members = [ {MyHordeRegistry, :node1}, {MyHordeRegistry, :node2}, {MyHordeRegistry, :node3}, {MyHordeRegistry, :node4} ] children = [ {Horde.Registry, name: MyHordeRegistry, keys: :unique, members: registry_members}, {Horde.DynamicSupervisor, name: MyHordeSupervisor, strategy: :one_for_one, members: supervisor_members}, ... ] This is the simplest approach. You tell Horde which members are supposed to be in the cluster, and if they are available, Horde will include them in the cluster."},{"ref":"libcluster.html#dynamic-cluster-membership","title":"Setting up a Cluster - Dynamic Cluster Membership","type":"extras","doc":"If you will be adding and removing nodes from your cluster constantly, and don&#39;t want to repackage your application every time you do this, then you will need to perform a couple of extra steps. In this scenario, you will need to implement a module-based Supervisor defmodule MyHordeSupervisor do use Horde.DynamicSupervisor def init(options) do {:ok, Keyword.put(options, :members, get_members())} end defp get_members() do [Node.self() | Node.list()] |&gt; Enum.map(fn node -&gt; {MyHordeSupervisor, node} end) end end Now every time MyHordeSupervisor gets started or restarted, it will compute the members based on the currently connected members. In this scenario, you may also want to implement a module-based Registry defmodule MyHordeRegistry do use Horde.Registry def init(options) do {:ok, Keyword.put(options, :members, get_members())} end defp get_members() do [Node.self() | Node.list()] |&gt; Enum.map(fn node -&gt; {MyHordeRegistry, node} end) end end Now every time MyHordeRegistry gets started or restarted, it will compute the members based on the currently connected members. We also need a separate process that will listen for {:nodeup, node} and {:nodedown, node} events and adjust the members of the Horde cluster accordingly. Put this in your supervision tree underneath MyHordeSupervisor. defmodule NodeListener do use GenServer def start_link(), do: GenServer.start_link(__MODULE__, []) def init(_) do :net_kernel.monitor_nodes(true, node_type: :visible) {:ok, nil} end def handle_info({:nodeup, _node, _node_type}, state) do set_members(MyHordeRegistry) set_members(MyHordeSupervisor) {:noreply, state} end def handle_info({:nodedown, _node, _node_type}, state) do set_members(MyHordeRegistry) set_members(MyHordeSupervisor) {:noreply, state} end defp set_members(name) do members = [Node.self() | Node.list()] |&gt; Enum.map(fn node -&gt; {name, node} end) :ok = Horde.Cluster.set_members(name, members) end end"}]